package com.ruoyi.web.v3.service.impl;

import cn.hutool.core.bean.BeanUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.web.v3.entity.HbEquipMaintenanceMonthlyEntity;
import com.ruoyi.web.v3.mapper.HbEquipMaintenanceMonthlyMapper;
import com.ruoyi.web.v3.model.request.HbEquipMaintenanceMonthlyPageReq;
import com.ruoyi.web.v3.service.IHbEquipMaintenanceMonthlyService;
import com.ruoyi.web.v3.utils.QueryWrapperBuildUtil;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.util.ObjectUtils;

import java.util.Arrays;

import static com.ruoyi.common.core.domain.AjaxResult.error;
import static com.ruoyi.common.core.domain.AjaxResult.success;

/**
 * <p>
 * v3.0 设备维保记录（月次） 服务实现类
 * </p>
 *
 */
@Service
public class HbEquipMaintenanceMonthlyServiceImpl extends ServiceImpl<HbEquipMaintenanceMonthlyMapper, HbEquipMaintenanceMonthlyEntity> implements IHbEquipMaintenanceMonthlyService {

    @Transactional
    @Override
    public AjaxResult add(HbEquipMaintenanceMonthlyEntity request) {
        //入参检测
        if(ObjectUtils.isEmpty(request.getEquipNameGroup())) {
            return error("请输入【屠宰设备名称】！");
        }
        //防重检测，
//        Integer count = lambdaQuery().eq(HbEquipMaintenanceMonthlyEntity::getRecordId, request.getRecordId()).count();
//        if (count != 0) {
//            return error("请勿重复添加！");
//        }
        return success("添加成功", baseMapper.insert(request));
    }

    @Transactional
    @Override
    public AjaxResult edit(HbEquipMaintenanceMonthlyEntity request) {
        //数据格式校验
        if(ObjectUtils.isEmpty(request.getId())){
            return error("待更新数据未传入有效ID，请设置数据的唯一标识ID！");
        }
        //根据数据的id更新所有不为空的字段
        return updateById(request) ? success("修改成功！") : error("修改失败，请重试！");
    }

    @Transactional
    @Override
    public AjaxResult delete(String ids) {
        String[] idList = ids.split(",");
        return success("删除成功", removeByIds(Arrays.asList(idList)));
    }

    @Override
    public AjaxResult page(HbEquipMaintenanceMonthlyPageReq request) {
        //将请求报文转为实体类
        HbEquipMaintenanceMonthlyEntity entity = BeanUtil.toBean(request, HbEquipMaintenanceMonthlyEntity.class);
        //构造查询条件（检索条件未定时，先按不为空的字段进行等值查询）
        QueryWrapper<HbEquipMaintenanceMonthlyEntity> wrapper = QueryWrapperBuildUtil.notNoneEqWrapperHelper(entity);
        return success(baseMapper.selectPage(request.toPage(), wrapper));
    }

    @Override
    public AjaxResult listAll() {
        return success(lambdaQuery().list());
    }
}
